<template>
  <div class="data-table__cell data-table-filter" :class="{ 'data-table-filter--is-active': isFilterActive()}">
    <input class="data-table-filter__input" type="text" placeholder="Enter" v-model="input" @keyup.enter="enableFilter()" />
    <span v-if="isFilterActive()" class="material-icons-outlined data-table-filter__icon" @click="disableFilter()">close</span>
    <span v-else class="material-icons-outlined data-table-filter__icon" @click="enableFilter()">filter_alt</span>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapActions, mapState } from 'vuex';
import { Filter } from '@/types/index';

export default Vue.extend({
  name: 'DataTableFilter',

  props: {
    fieldName: {
      required: true,
      type: String
    }
  },

  data () {
    return {
      input: ''
    };
  },

  computed: {
    ...mapState({
      activeFilters: (state: any) => state.characters.activeFilters as Filter[]
    })
  },

  methods: {
    ...mapActions([
      'removeFilter',
      'setFilter'
    ]),

    disableFilter (): void {
      this.input = '';
      this.removeFilter(this.fieldName);
    },

    enableFilter (): void {
      if (!this.input.trim()) {
        return;
      }

      this.setFilter({ fieldName: this.fieldName, value: this.input.trim() });
    },

    isFilterActive (): boolean {
      return this.activeFilters.some((filter: Filter) => filter.fieldName === this.fieldName);
    }
  }
});
</script>

<style lang="scss" scoped>
.data-table-filter {
  &__input {
    width: 100%;
    padding: .3rem;
    border-radius: 4px;
    border: 1px solid var(--color-primary);
  }

  &__icon {
    cursor: pointer;
    opacity: .5;
    transition: opacity 180ms ease-in-out;
  }

  &--is-active {
    .data-table-filter__input {
      border-color: var(--color-accent);
    }

    .data-table-filter__icon {
      opacity: 1;
    }
  }
}
</style>
